GPS_Event = {};
  GPS_Event_mt = Class(GPS_Event, Event);
  
  --InitStaticEventClass(GPS_Event, "GPS_Event");
  InitEventClass(GPS_Event, "GPS_Event");
  
  function GPS_Event:emptyNew()
      local self = Event:new(GPS_Event_mt);
      return self;
  end;
  
  function GPS_Event:new(object, x,z,dx,dz,w,o)
      local self = GPS_Event:emptyNew()
      self.x = x;
	  self.z = z;
	  self.dx = dx;
	  self.dz = dz;
	  self.w = w;
	  self.o = o;
	  
      self.object = object;
      return self;
  end;
  
  function GPS_Event:readStream(streamId, connection)
      local id = streamReadInt32(streamId);
      self.x = streamReadFloat32(streamId);
	  self.z = streamReadFloat32(streamId);
	  self.dx = streamReadFloat32(streamId);
	  self.dz = streamReadFloat32(streamId);
	  self.w = streamReadFloat32(streamId);
	  self.o = streamReadFloat32(streamId);
      
	  
	  self.object = networkGetObject(id);
      self:run(connection);
  end;
  
  function GPS_Event:writeStream(streamId, connection)
      streamWriteInt32(streamId, networkGetObjectId(self.object));
	  streamWriteFloat32(streamId, self.x);
	  streamWriteFloat32(streamId, self.z);
	  streamWriteFloat32(streamId, self.dx);
	  streamWriteFloat32(streamId, self.dz);
	  streamWriteFloat32(streamId, self.w);
	  streamWriteFloat32(streamId, self.o);

  end;
  
  function GPS_Event:run(connection)
	  self.object.lhX0 = self.x;
	  self.object.lhZ0 = self.z;
	  self.object.lhdX0 = self.dx;
	  self.object.lhdZ0 = self.dz;
	  self.object.GPSWidth = self.w;
	  self.object.GPS_LRoffset = self.o;
	  
      --self.object:setBeaconLightsVisibility(self.active, true);
      if not connection:getIsServer() then
          g_server:broadcastEvent(GPS_Event:new(self.object, self.x, self.z, self.dx, self.dz, self.w, self.o), nil, connection, self.object);
      end;
  end;